/*
 * JBoss, Home of Professional Open Source
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.ejb.plugins.cmp.jdbc.keygen;

import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.sql.ResultSet;
import java.sql.Statement;
import java.lang.reflect.Method;
import java.lang.reflect.InvocationTargetException;

import javax.ejb.EJBException;

import org.jboss.ejb.plugins.cmp.jdbc.JDBCIdentityColumnCreateCommand;
import org.jboss.ejb.plugins.cmp.jdbc.JDBCStoreManager;
import org.jboss.ejb.plugins.cmp.jdbc.JDBCUtil;
import org.jboss.ejb.plugins.cmp.jdbc.metadata.JDBCEntityCommandMetaData;
import org.jboss.ejb.EntityEnterpriseContext;
import org.jboss.deployment.DeploymentException;
import org.jboss.logging.Logger;

/**
 * Create command for MySQL that uses the driver's getGeneratedKeys method
 * to retrieve AUTO_INCREMENT values.
 *
 * @author <a href="mailto:jeremy@boynes.com">Jeremy Boynes</a>
 * @author Scott.Stark@jboss.org
 * @version $Revision: 1.6.2.1 $
 */
public class JDBCMySQLCreateCommand extends JDBCIdentityColumnCreateCommand
{
   private static final Logger log = Logger.getLogger(JDBCMySQLCreateCommand.class);
   private String className;
   private String methodName;
   private Method method;
   private Method getUnderlyingStatement;

   public void init(JDBCStoreManager manager) throws DeploymentException
   {
      super.init(manager);
      ClassLoader loader = GetTCLAction.getContextClassLoader();
      try
      {
         Class psClass = loader.loadClass(className);
         method = psClass.getMethod(methodName, null);
      }
      catch (ClassNotFoundException e)
      {
         throw new DeploymentException("Could not load driver class: " + className, e);
      }
      catch (NoSuchMethodException e)
      {
         throw new DeploymentException("Driver does not have method: " + methodName + "()");
      }

      try
      {
         Class wrapperClass = loader.loadClass("org.jboss.resource.adapter.jdbc.StatementAccess");
         getUnderlyingStatement = wrapperClass.getMethod("getUnderlyingStatement", null);
      }
      catch (ClassNotFoundException e)
      {
         throw new DeploymentException("Could not load org.jboss.resource.adapter.jdbc.StatementAccess", e);
      }
      catch (NoSuchMethodException e)
      {
         throw new DeploymentException("StatementAccess.getUnderlyingStatement not found", e);
      }
   }

   protected void initEntityCommand(JDBCEntityCommandMetaData entityCommand) throws DeploymentException
   {
      super.initEntityCommand(entityCommand);
      className = entityCommand.getAttribute("class-name");
      if (className == null)
      {
         className = "com.mysql.jdbc.PreparedStatement";
      }
      methodName = entityCommand.getAttribute("method");
      if (methodName == null)
      {
         methodName = "getGeneratedKeys";
      }
   }

   protected int executeInsert(int paramIndex, PreparedStatement ps, EntityEnterpriseContext ctx) throws SQLException
   {
      int rows = ps.executeUpdate();

      // remove any JCA wrappers
      Statement stmt = ps;
      do
      {
         try
         {
            Object[] args = {};
            stmt = (Statement) getUnderlyingStatement.invoke(stmt, args);
         }
         catch (IllegalAccessException e)
         {
            SQLException ex = new SQLException("Failed to invoke getUnderlyingStatement");
            ex.initCause(e);
            throw ex;
         }
         catch (InvocationTargetException e)
         {
            SQLException ex = new SQLException("Failed to invoke getUnderlyingStatement");
            ex.initCause(e);
            throw ex;
         }
      } while (stmt != null && method.getDeclaringClass().isInstance(stmt) == false);

      ResultSet rs = null;
      try
      {
         rs = (ResultSet) method.invoke(stmt, null);
         if (!rs.next())
         {
            throw new EJBException("getGeneratedKeys returned an empty ResultSet");
         }
         pkField.loadInstanceResults(rs, 1, ctx);
      }
      catch (RuntimeException e)
      {
         throw e;
      }
      catch (Exception e)
      {
         // throw EJBException to force a rollback as the row has been inserted
         throw new EJBException("Error extracting generated keys", e);
      }
      finally
      {
         JDBCUtil.safeClose(rs);
      }
      return rows;
   }
}
